Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 501468 - www-client/firefox-27.0, mail-client/thunderbird-24.3.0 - linker weirdness with libmozalloc.so libxul.so
Summary: www-client/firefox-27.0, mail-client/thunderbird-24.3.0 - linker weirdness wi...
Status: RESOLVED OBSOLETE
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Tools (show other bugs)
Hardware: AMD64 Linux
: Normal normal with 1 vote (vote)
Assignee: Portage Tools Team
URL:
Whiteboard:
Keywords:
: 506482 (view as bug list)
Depends on:
Blocks:
 
Reported: 2014-02-16 11:22 UTC by Cănărău Constantin
Modified: 2019-01-06 18:06 UTC (History)
10 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
Output of `revdep-rebuild -ipv'` (firefox_revdeprebuild_bug.txt,3.67 KB, text/plain)
2014-03-14 23:11 UTC, Dmitry Derevyanko
Details
Revdep-rebuild files from /var/cache/revdep-rebuild/* (revdep_rebuild_rr.tar,610.00 KB, application/x-tar)
2014-03-14 23:12 UTC, Dmitry Derevyanko
Details
LD_LIBRARY_PATH="revdep-rebuild/2_ldpath.rr" ldd libbrowsercomps.so (firefox_revdeprebuild_bug.txt,9.82 KB, text/plain)
2014-03-17 19:13 UTC, Dmitry Derevyanko
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Cănărău Constantin 2014-02-16 11:22:01 UTC
Since I compiled firefox 27.0, revdep-rebuild keep rebuild firefox

Reproducible: Always

Steps to Reproduce:
1. Compile firefox 27.0
2. Run revdep-rebuild
3.
Actual Results:  
Mozilla firefox is always rebuild by revdep-rebuild

Expected Results:  
revdep-rebuild stop rebuild firefox

Mozilla Firefox is rebuild every time I use revdep-rebuild

revdep-rebuild -p -i
 * Configuring search environment for revdep-rebuild

 * Checking reverse dependencies
 * Packages containing binaries and libraries broken by a package update
 * will be emerged.

 * Collecting system binaries and libraries
 * Generated new 1_files.rr
 * Collecting complete LD_LIBRARY_PATH
 * Generated new 2_ldpath.rr
 * Checking dynamic linking consistency
[ 46% ]  *   broken /usr/lib64/firefox/browser/components/libbrowsercomps.so (requires libmozalloc.so
libxul.so)
 *   broken /usr/lib64/firefox/components/libdbusservice.so (requires libmozalloc.so
libxul.so)
 *   broken /usr/lib64/firefox/components/libmozgnome.so (requires libmozalloc.so
libxul.so)
 *   broken /usr/lib64/firefox/plugin-container (requires libxul.so)
[ 100% ]                 
 * Generated new 3_broken.rr
 * Assigning files to packages
 *   /usr/lib64/firefox/browser/components/libbrowsercomps.so -> www-client/firefox
 *   /usr/lib64/firefox/components/libdbusservice.so -> www-client/firefox
 *   /usr/lib64/firefox/components/libmozgnome.so -> www-client/firefox
 *   /usr/lib64/firefox/plugin-container -> www-client/firefox
 * Generated new 4_raw.rr and 4_owners.rr
 * Cleaning list of packages to rebuild
 * Generated new 4_pkgs.rr
 * Assigning packages to ebuilds
 * Generated new 4_ebuilds.rr
 * Evaluating package order
 * Generated new 5_order.rr
 * All prepared. Starting rebuild
emerge --complete-graph=y --oneshot --jobs=4 --load-average=10 --keep-going --with-bdeps=y --complete-graph --quiet-build=n --autounmask-write --pretend www-client/firefox:0

These are the packages that would be merged, in order:

Calculating dependencies                                       ... done!
[ebuild   R    ] www-client/firefox-27.0 
 * Now you can remove -p (or --pretend) from arguments and re-run revdep-rebuild.


ldd /usr/lib64/firefox/browser/components/libbrowsercomps.so
	linux-vdso.so.1 (0x00007fff733ff000)
	libpthread.so.0 => /lib64/libpthread.so.0 (0x00007fc55c116000)
	libxul.so => not found
	libmozalloc.so => not found
	libnspr4.so => /usr/lib64/libnspr4.so (0x00007fc55beda000)
	libgdk-x11-2.0.so.0 => /usr/lib64/libgdk-x11-2.0.so.0 (0x00007fc55bc27000)
	libgdk_pixbuf-2.0.so.0 => /usr/lib64/libgdk_pixbuf-2.0.so.0 (0x00007fc55ba06000)
	libgobject-2.0.so.0 => /usr/lib64/libgobject-2.0.so.0 (0x00007fc55b7b8000)
	libglib-2.0.so.0 => /usr/lib64/libglib-2.0.so.0 (0x00007fc55b486000)
	libstdc++.so.6 => /usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2/libstdc++.so.6 (0x00007fc55b181000)
	libc.so.6 => /lib64/libc.so.6 (0x00007fc55adde000)
	/lib64/ld-linux-x86-64.so.2 (0x00007fc55c37c000)
	libdl.so.2 => /lib64/libdl.so.2 (0x00007fc55abda000)
	librt.so.1 => /lib64/librt.so.1 (0x00007fc55a9d1000)
	libpangocairo-1.0.so.0 => /usr/lib64/libpangocairo-1.0.so.0 (0x00007fc55a7c4000)
	libpango-1.0.so.0 => /usr/lib64/libpango-1.0.so.0 (0x00007fc55a572000)
	libgio-2.0.so.0 => /usr/lib64/libgio-2.0.so.0 (0x00007fc55a1ff000)
	libfontconfig.so.1 => /usr/lib64/libfontconfig.so.1 (0x00007fc559fc2000)
	libfreetype.so.6 => /usr/lib64/libfreetype.so.6 (0x00007fc559d1b000)
	libXrender.so.1 => /usr/lib64/libXrender.so.1 (0x00007fc559b10000)
	libXi.so.6 => /usr/lib64/libXi.so.6 (0x00007fc559901000)
	libXrandr.so.2 => /usr/lib64/libXrandr.so.2 (0x00007fc5596f8000)
	libXcursor.so.1 => /usr/lib64/libXcursor.so.1 (0x00007fc5594ec000)
	libXcomposite.so.1 => /usr/lib64/libXcomposite.so.1 (0x00007fc5592e9000)
	libXdamage.so.1 => /usr/lib64/libXdamage.so.1 (0x00007fc5590e6000)
	libXfixes.so.3 => /usr/lib64/libXfixes.so.3 (0x00007fc558edf000)
	libcairo.so.2 => /usr/lib64/libcairo.so.2 (0x00007fc558bc1000)
	libX11.so.6 => /usr/lib64/libX11.so.6 (0x00007fc55888e000)
	libXext.so.6 => /usr/lib64/libXext.so.6 (0x00007fc55867c000)
	libm.so.6 => /lib64/libm.so.6 (0x00007fc55837d000)
	libgmodule-2.0.so.0 => /usr/lib64/libgmodule-2.0.so.0 (0x00007fc558179000)
	libpng16.so.16 => /usr/lib64/libpng16.so.16 (0x00007fc557f43000)
	libffi.so.6 => /usr/lib64/libffi.so.6 (0x00007fc557d3b000)
	libgcc_s.so.1 => /usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2/libgcc_s.so.1 (0x00007fc557b25000)
	libpangoft2-1.0.so.0 => /usr/lib64/libpangoft2-1.0.so.0 (0x00007fc557910000)
	libgthread-2.0.so.0 => /usr/lib64/libgthread-2.0.so.0 (0x00007fc55770e000)
	libharfbuzz.so.0 => /usr/lib64/libharfbuzz.so.0 (0x00007fc5574c1000)
	libz.so.1 => /lib64/libz.so.1 (0x00007fc5572aa000)
	libresolv.so.2 => /lib64/libresolv.so.2 (0x00007fc557093000)
	libexpat.so.1 => /usr/lib64/libexpat.so.1 (0x00007fc556e6b000)
	libbz2.so.1 => /lib64/libbz2.so.1 (0x00007fc556c59000)
	libpixman-1.so.0 => /usr/lib64/libpixman-1.so.0 (0x00007fc5569c3000)
	libEGL.so.1 => /usr/lib64/libEGL.so.1 (0x00007fc5566c1000)
	libxcb-shm.so.0 => /usr/lib64/libxcb-shm.so.0 (0x00007fc5564be000)
	libxcb-render.so.0 => /usr/lib64/libxcb-render.so.0 (0x00007fc5562b4000)
	libxcb.so.1 => /usr/lib64/libxcb.so.1 (0x00007fc556096000)
	libGL.so.1 => /usr/lib64/libGL.so.1 (0x00007fc555d61000)
	libgraphite2.so.3 => /usr/lib64/libgraphite2.so.3 (0x00007fc555b44000)
	libnvidia-glsi.so.334.16 => /usr/lib64/libnvidia-glsi.so.334.16 (0x00007fc5558bd000)
	libXau.so.6 => /usr/lib64/libXau.so.6 (0x00007fc5556b8000)
	libXdmcp.so.6 => /usr/lib64/libXdmcp.so.6 (0x00007fc5554b2000)
	libnvidia-tls.so.334.16 => /usr/lib64/libnvidia-tls.so.334.16 (0x00007fc5552af000)
	libnvidia-glcore.so.334.16 => /usr/lib64/libnvidia-glcore.so.334.16 (0x00007fc552936000)



locate libmozalloc.so libxul.so
/opt/komodo-edit-bin-8.5.3/lib/mozilla/libmozalloc.so
/opt/komodo-edit-bin-8.5.3/lib/mozilla/libxul.so
/usr/lib64/firefox/libmozalloc.so
/usr/lib64/firefox/libxul.so
/usr/lib64/thunderbird/libmozalloc.so
/usr/lib64/thunderbird/libxul.so


emerge --info firefox
Portage 2.2.8-r1 (default/linux/amd64/13.0/desktop/gnome/systemd, gcc-4.8.2, glibc-2.19, 3.13.3-aufs-costel x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-3.13.3-aufs-costel-x86_64-Intel-R-_Core-TM-_i7_CPU_860_@_2.80GHz-with-gentoo-2.2
KiB Mem:    16427944 total,   3789004 free
KiB Swap:          0 total,         0 free
Timestamp of tree: Sun, 16 Feb 2014 09:15:01 +0000
ld GNU ld (GNU Binutils) 2.24
app-shells/bash:          4.2_p45-r1
dev-java/java-config:     2.2.0
dev-lang/python:          2.7.6, 3.3.3
dev-util/cmake:           2.8.12.2
dev-util/pkgconfig:       0.28
sys-apps/baselayout:      2.2
sys-apps/openrc:          0.12.4
sys-apps/sandbox:         2.6-r1
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.11.6, 1.14.1
sys-devel/binutils:       2.24-r2
sys-devel/gcc:            4.8.2-r1
sys-devel/gcc-config:     1.8
sys-devel/libtool:        2.4.2
sys-devel/make:           4.0-r1
sys-kernel/linux-headers: 3.13 (virtual/os-headers)
sys-libs/glibc:           2.19
Repositories: gentoo added
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -march=native -w"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt /var/bind"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.5/ext-active/ /etc/php/cgi-php5.5/ext-active/ /etc/php/cli-php5.5/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -pipe -march=native -w"
DISTDIR="/mnt/linux/distfiles"
EMERGE_DEFAULT_OPTS="--jobs=4 --load-average=10 --keep-going --with-bdeps=y --complete-graph --quiet-build=n --autounmask-write"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs candy cgroup collision-protect config-protect-if-modified distlocks fail-clean fixlafiles ipc-sandbox merge-sync news nodoc noinfo parallel-fetch parallel-install preserve-libs protect-owned sandbox sfperms strict unknown-features-filter unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://ftp.romnet.org/gentoo/ http://mirrors.xservers.ro/gentoo/ ftp://ftp.romnet.org/gentoo/ http://ftp.roedu.net/pub/mirrors/gentoo.org/ http://distfiles.gentoo.org/"
LANG="ro_RO.UTF-8"
LC_ALL="ro_RO.UTF-8"
LDFLAGS="-Wl,-O1,--sort-common,--hash-style=gnu,--as-needed,-z,now"
MAKEOPTS="-j8 --load-average=10"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_EXTRA_OPTS="--human-readable --delete-before --progress"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/portage/local/added"
USE="X a52 aac acl acpi alsa amd64 berkdb branding bzip2 cairo cdda cdr cli colord cracklib crypt cups cxx dbus dri dts dvd dvdr eds emboss encode evo exif fam firefox flac gdbm gif gmp gnome gnome-keyring gnome-online-accounts gpm gstreamer gtk gtk3 iconv introspection ipv6 ithreads jpeg lcms ldap libnotify libsecret logrotate mad mmx mng modules mp3 mp4 mpeg multilib mysql nautilus ncurses networkmanager nls nptl ogg opengl openmp opus pam pango pch pcre pdf png policykit postgres ppds pulseaudio qt3support qt4 readline sdl session socialweb spell sse sse2 sse4_1 sse4_2 ssl ssse3 startup-notification svg systemd tcpd theora threads tiff truetype udev udisks unicode upower usb vdpau vhosts vorbis wxwidgets x264 xcb xml xv xvid zlib" ABI_X86="64" ALSA_CARDS="virtuoso hda-intel" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="pc" INPUT_DEVICES="evdev keyboard mouse" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="ro en" NGINX_MODULES_HTTP="access auth_basic autoindex browser charset empty_gif fastcgi geo gunzip gzip limit_conn limit_req map memcached naxsi proxy referer rewrite scgi split_clients ssi upstream_ip_hash userid uwsgi addition cache_purge dav fancyindex flv geoip gzip_static headers_more image_filter mp4 perl push random_index realip secure_link spdy stub_status sub upload_progress xslt" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-5" PYTHON_SINGLE_TARGET="python2_7 python 3_3" PYTHON_TARGETS="python2_7 python3_3" RUBY_TARGETS="ruby20" USERLAND="GNU" VIDEO_CARDS="nv nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, INSTALL_MASK, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, SYNC, USE_PYTHON

=================================================================
                        Package Settings
=================================================================

www-client/firefox-27.0 was built with the following:
USE="alsa dbus gstreamer jit libnotify minimal (multilib) pulseaudio startup-notification -bindist -custom-cflags -custom-optimization -debug (-pgo) (-selinux) -system-cairo -system-icu -system-jpeg -system-sqlite -wifi" ABI_X86="64" LINGUAS="ro -af -ar -as -ast -be -bg -bn_BD -bn_IN -br -bs -ca -cs -csb -cy -da -de -el -en_GB -en_ZA -eo -es_AR -es_CL -es_ES -es_MX -et -eu -fa -fi -fr -fy_NL -ga_IE -gd -gl -gu_IN -he -hi_IN -hr -hu -hy_AM -id -is -it -ja -kk -km -kn -ko -ku -lt -lv -mai -mk -ml -mr -nb_NO -nl -nn_NO -or -pa_IN -pl -pt_BR -pt_PT -rm -ru -si -sk -sl -son -sq -sr -sv_SE -ta -te -th -tr -uk -vi -xh -zh_CN -zh_TW -zu"
CFLAGS="-pipe -march=native -w -mno-avx"
CXXFLAGS="-pipe -march=native -w -mno-avx"
Comment 1 Brian Dolbec gentoo-dev 2014-02-16 15:01:00 UTC
Can you please try the python version of revdep-rebuild in current gentoolkit-9999.  I've recently done some more work on it.  The python version is the default in gentoolkit-9999.  We are thinking to make it the default for the next release as well.
Comment 2 Cănărău Constantin 2014-02-16 15:02:28 UTC
revdep-rebuild it's not the only one which can't find libraries.
ldd, also, can't find them:

ldd /usr/lib64/firefox/browser/components/libbrowsercomps.so
	linux-vdso.so.1 (0x00007ffff4144000)
	libpthread.so.0 => /lib64/libpthread.so.0 (0x00007fd2ceab3000)
	libxul.so => not found
	libmozalloc.so => not found
...

ldd /usr/lib64/firefox/components/libdbusservice.so
	linux-vdso.so.1 (0x00007fff335ff000)
	libpthread.so.0 => /lib64/libpthread.so.0 (0x00007f131a774000)
	libxul.so => not found
	libmozalloc.so => not found
....

ldd /usr/lib64/firefox/plugin-container
	linux-vdso.so.1 (0x00007fffc2731000)
	libpthread.so.0 => /lib64/libpthread.so.0 (0x00007ff230315000)
	libxul.so => not found
	libstdc++.so.6 => /usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2/libstdc++.so.6 (0x00007ff230011000)
	libm.so.6 => /lib64/libm.so.6 (0x00007ff22fd11000)
	libc.so.6 => /lib64/libc.so.6 (0x00007ff22f96e000)
	/lib64/ld-linux-x86-64.so.2 (0x00007ff230532000)
	libgcc_s.so.1 => /usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2/libgcc_s.so.1 (0x00007ff22f758000)

I use glibc-2.19. Unfortunatelly it's not possible to downlograde to 2.18 to see if the error persist.
Comment 3 Cănărău Constantin 2014-02-16 15:24:56 UTC
revdep-rebuild -p -i
 * This is a prerelease version, so it may not work correctly
 * The original revdep-rebuild script is installed as revdep-rebuild.sh
 * Please files bugs at: https://bugs.gentoo.org/
 * Collecting system binaries and libraries
 * Checking dynamic linking consistency
 * Assign files to packages

emerge  --pretend --oneshot --complete-graph=y www-servers/nginx:0 app-office/libreoffice:0

These are the packages that would be merged, in order:

Calculating dependencies                   ... done!            
[ebuild   R    ] www-servers/nginx-1.4.4 
[ebuild   R    ] app-office/libreoffice-4.2.0.4 

It seems that firefox has been replaced with libreoffice and nginx. I recompiled nginx and ran the toold again, but nginx was still in the list.
But the new version of revdep-rebuild is much, much faster than previous one.

I'm still not convinced that it's revdep-rebuild foud as ldd report the error too. Regading new version of revdep-rebuild:

revdep-rebuild -p -i -v
 * This is a prerelease version, so it may not work correctly
 * The original revdep-rebuild script is installed as revdep-rebuild.sh
 * Please files bugs at: https://bugs.gentoo.org/
 * Collecting system binaries and libraries
 * Collecting dynamic linking informations
 * Scanning files
 * Checking dynamic linking consistency
 * Broken files that requires: libperl.so (64 bits)
	* /usr/sbin/nginx
 * Broken files that requires: libjawt.so (64 bits)
	* /usr/lib64/libreoffice/program/libofficebean.so
 * Assign files to packages
	* /usr/sbin/nginx -> www-servers/nginx-1.4.4
	* /usr/lib64/libreoffice/program/libofficebean.so -> app-office/libreoffice-4.2.0.4

emerge  --pretend --verbose --oneshot --complete-graph=y app-office/libreoffice:0 www-servers/nginx:0
....

ldd found many errors in 
ldd /opt/icedtea-bin-7.2.4.3/jre/lib/amd64/libjawt.so
	linux-vdso.so.1 (0x00007fff939ff000)
	libawt.so => /opt/icedtea-bin-7.2.4.3/jre/lib/amd64/libawt.so (0x00007f408b9d8000)
	libmawt.so => not found
	libjava.so => /opt/icedtea-bin-7.2.4.3/jre/lib/amd64/libjava.so (0x00007f408b774000)
	libjvm.so => not found
	libc.so.6 => /lib64/libc.so.6 (0x00007f408b3d0000)
	libjvm.so => not found
	libm.so.6 => /lib64/libm.so.6 (0x00007f408b0d1000)
	libdl.so.2 => /lib64/libdl.so.2 (0x00007f408aecc000)
	libjvm.so => not found
	libverify.so => /opt/icedtea-bin-7.2.4.3/jre/lib/amd64/libverify.so (0x00007f408acbd000)
	/lib64/ld-linux-x86-64.so.2 (0x00007f408beb0000)
	libjvm.so => not found

but none in ldd /usr/lib64/libperl.so 
	linux-vdso.so.1 (0x00007fff969ff000)
	libnsl.so.1 => /lib64/libnsl.so.1 (0x00007f1b13b7e000)
	libdl.so.2 => /lib64/libdl.so.2 (0x00007f1b1397a000)
	libm.so.6 => /lib64/libm.so.6 (0x00007f1b1367a000)
	libcrypt.so.1 => /lib64/libcrypt.so.1 (0x00007f1b13443000)
	libutil.so.1 => /lib64/libutil.so.1 (0x00007f1b13240000)
	libpthread.so.0 => /lib64/libpthread.so.0 (0x00007f1b13022000)
	libc.so.6 => /lib64/libc.so.6 (0x00007f1b12c7f000)
	/lib64/ld-linux-x86-64.so.2 (0x00007f1b1415d000)
Comment 4 Brian Dolbec gentoo-dev 2014-02-16 15:54:09 UTC
Generally, anything perl related... run perl-cleaner --reallyall

but before you do...

please run:

scanelf -nB /usr/sbin/nginx

it will list the needed libraries. Revdep then checks that the needed libraries exist.  If the libraries are not found in the PATH it reports that as broken.  Please check the path settings to see if that might be causing the nginx breakage detection.

But also, why is it not picking up firefox breakage if ldd is also reporting them missing?
Comment 5 Cănărău Constantin 2014-02-16 16:24:55 UTC
scanelf -nB /usr/sbin/nginx
ET_EXEC libpthread.so.0,libcrypt.so.1,libpcre.so.1,libssl.so.1.0.0,libcrypto.so.1.0.0,libz.so.1,libxml2.so.2,libxslt.so.1,libexslt.so.0,libgd.so.2,libGeoIP.so.1,libperl.so,libc.so.6 /usr/sbin/nginx 

echo $PATH
/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/opt/bin:/usr/x86_64-pc-linux-gnu/gcc-bin/4.8.2

Some of depending libraries are in /lib64 others in /usr/lib64. All of them are present, including the files they are pointed.
Comment 6 Brian Dolbec gentoo-dev 2014-02-16 21:04:20 UTC
I just emerged firefox-27 this morning.  Without doing anything else:

revdep-rebuild python version did not report anything I didn't already know about.

ld reported the same missing links as yours did:

big_daddy gentoolkit # ldd /usr/lib64/firefox/browser/components/libbrowsercomps.so
	linux-vdso.so.1 (0x00007fffbbbf5000)
	libpthread.so.0 => /lib64/libpthread.so.0 (0x00007fa241e13000)
	libxul.so => not found
	libmozalloc.so => not found
        ...

revdep-rebuild.sh also does not report anything not already known.

big_daddy portage # locate libmozalloc.so libxul.so
/usr/lib64/firefox/libmozalloc.so
/usr/lib64/firefox/libxul.so


So, the libs are there, but ld for some reason is not linking them.  But since the libs are present, revdep is not detecting libs linking to them broken.  It does not check the actual link that the ldd command reports.

big_daddy portage # gcc-config -l
 [1] x86_64-pc-linux-gnu-4.6.4
 [2] x86_64-pc-linux-gnu-4.7.3
 [3] x86_64-pc-linux-gnu-4.8.2 *
big_daddy portage # emerge --info
Portage 2.2.8_p47 (default/linux/amd64/13.0/desktop, gcc-4.8.2, glibc-2.18-r1, 3.7.4-gentoo x86_64)
=================================================================
System uname: Linux-3.7.4-gentoo-x86_64-Intel-R-_Core-TM-2_Quad_CPU_Q8400_@_2.66GHz-with-gentoo-2.2
KiB Mem:     4051868 total,     77072 free
KiB Swap:    7343692 total,   5853108 free
Timestamp of tree: Sun, 16 Feb 2014 15:00:01 +0000
ld GNU ld (GNU Binutils) 2.24
ccache version 3.1.9 [enabled]
app-shells/bash:          4.2_p45-r1
dev-java/java-config:     2.2.0
dev-lang/python:          2.5.4-r6, 2.6.9, 2.7.6, 3.1.5-r1, 3.2.5-r3, 3.3.3
dev-util/ccache:          3.1.9-r3
dev-util/cmake:           2.8.12.2
dev-util/pkgconfig:       0.28
sys-apps/baselayout:      2.2
sys-apps/openrc:          0.12.4
sys-apps/sandbox:         2.6-r1
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.7.9-r2, 1.8.5-r4, 1.9.6-r3, 1.10.3, 1.11.6, 1.12.6, 1.13.4, 1.14.1
sys-devel/binutils:       2.24-r2
sys-devel/gcc:            4.6.4, 4.7.3-r1, 4.8.2
sys-devel/gcc-config:     1.8
sys-devel/libtool:        2.4.2
sys-devel/make:           4.0-r1
sys-kernel/linux-headers: 3.13 (virtual/os-headers)
sys-libs/glibc:           2.18-r1
...

This eliminates the glibc-2.19 thought for teh cause of the breakage.

I've just added more debug info to the --d, --debug output to help see if the missing libs are being masked or missing from the search environment.

please re-emerge gentoolkit-9999 and retest.
Comment 7 Cănărău Constantin 2014-02-17 10:20:26 UTC
New revdep-rebuild found the same nginx and libreoffice but fail during debug phase:

revdep-rebuild -p -i -v
 * This is a prerelease version, so it may not work correctly
 * The original revdep-rebuild script is installed as revdep-rebuild.sh
 * Please files bugs at: https://bugs.gentoo.org/
 * Collecting system binaries and libraries
 * Collecting dynamic linking informations
 * Scanning files
 * Checking dynamic linking consistency
 * Broken files that requires: libjawt.so (64 bits)
	* /usr/lib64/libreoffice/program/libofficebean.so
 * Broken files that requires: libperl.so (64 bits)
	* /usr/sbin/nginx
 * Assign files to packages
	* /usr/lib64/libreoffice/program/libofficebean.so -> app-office/libreoffice-4.2.0.4
	* /usr/sbin/nginx -> www-servers/nginx-1.4.4
Traceback (most recent call last):
  File "/usr/lib/python-exec/python3.3/revdep-rebuild", line 40, in <module>
    success = rebuild.main(rebuild.parse_options())
  File "/usr/lib64/python3.3/site-packages/gentoolkit/revdep_rebuild/rebuild.py", line 273, in main
    logger.debug("rebuild return code = %i" %success)
NameError: global name 'success' is not defined

Old revdep-rebuild found firefox:
revdep-rebuild.sh -p -i -v
 * Configuring search environment for revdep-rebuild
 * Temporary cache files are located in /var/cache/revdep-rebuild

revdep-rebuild environment:
SEARCH_DIRS="/bin
/lib
/lib32
/lib64
/opt/bin
/sbin
/usr/bin
/usr/games/bin
/usr/games/lib
/usr/games/lib32
/usr/games/lib64
/usr/lib
/usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2
/usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2/32
/usr/lib/postgresql
/usr/lib/qt4
/usr/lib32
/usr/lib32/OpenCL/vendors/nvidia
/usr/lib32/opengl/nvidia/lib
/usr/lib32/qt4
/usr/lib64
/usr/lib64/OpenCL/vendors/nvidia
/usr/lib64/opengl/nvidia/lib
/usr/lib64/postgresql
/usr/lib64/postgresql-9.3/lib64/
/usr/lib64/qca2
/usr/lib64/qt4
/usr/libexec
/usr/local/lib
/usr/local/lib32
/usr/local/lib64
/usr/sbin
/usr/x86_64-pc-linux-gnu/gcc-bin/4.8.2
/usr/x86_64-pc-linux-gnu/lib"
SEARCH_DIRS_MASK="/lib/modules
/lib64/modules
/opt/icedtea-bin-7.2.4.3
/usr/lib64/opera"
LD_LIBRARY_MASK="libjava.so
libjawt.so
libjvm.so
libodbc.so
libodbcinst.so"
PORTAGE_ROOT="/"
EMERGE_OPTIONS=""
ORDER_PKGS="1"
FULL_LD_PATH="1"

 * Checking reverse dependencies
 * Packages containing binaries and libraries broken by a package update
 * will be emerged.

 * Collecting system binaries and libraries
 * Generated new 1_files.rr
 * Collecting complete LD_LIBRARY_PATH
 * Generated new 2_ldpath.rr
 * Checking dynamic linking consistency
[ 46% ]  *   broken /usr/lib64/firefox/browser/components/libbrowsercomps.so (requires libmozalloc.so
libxul.so)
 *   broken /usr/lib64/firefox/components/libdbusservice.so (requires libmozalloc.so
libxul.so)
 *   broken /usr/lib64/firefox/components/libmozgnome.so (requires libmozalloc.so
libxul.so)
 *   broken /usr/lib64/firefox/plugin-container (requires libxul.so)
[ 100% ]                 
 * Generated new 3_broken.rr
 * Assigning files to packages
 *   /usr/lib64/firefox/browser/components/libbrowsercomps.so -> www-client/firefox
 *   /usr/lib64/firefox/components/libdbusservice.so -> www-client/firefox
 *   /usr/lib64/firefox/components/libmozgnome.so -> www-client/firefox
 *   /usr/lib64/firefox/plugin-container -> www-client/firefox
 * Generated new 4_raw.rr and 4_owners.rr
 * Cleaning list of packages to rebuild
 * Generated new 4_pkgs.rr
 * Assigning packages to ebuilds
 * Generated new 4_ebuilds.rr
 * Evaluating package order
 * Generated new 5_order.rr
 * All prepared. Starting rebuild
emerge --complete-graph=y --oneshot --jobs=4 --load-average=10 --keep-going --with-bdeps=y --complete-graph --quiet-build=n --autounmask-write --pretend --verbose www-client/firefox:0

These are the packages that would be merged, in order:

Calculating dependencies            ... done!                         
[ebuild   R    ] www-client/firefox-27.0  USE="alsa dbus gstreamer jit libnotify minimal pulseaudio startup-notification -bindist -custom-cflags -custom-optimization -debug (-pgo) (-selinux) -system-cairo -system-icu -system-jpeg -system-sqlite -wifi" LINGUAS="ro -af -ar -as -ast -be -bg -bn_BD -bn_IN -br -bs -ca -cs -csb -cy -da -de -el -en_GB -en_ZA -eo -es_AR -es_CL -es_ES -es_MX -et -eu -fa -fi -fr -fy_NL -ga_IE -gd -gl -gu_IN -he -hi_IN -hr -hu -hy_AM -id -is -it -ja -kk -km -kn -ko -ku -lt -lv -mai -mk -ml -mr -nb_NO -nl -nn_NO -or -pa_IN -pl -pt_BR -pt_PT -rm -ru -si -sk -sl -son -sq -sr -sv_SE -ta -te -th -tr -uk -vi -xh -zh_CN -zh_TW -zu" 0 kB

Total: 1 package (1 reinstall), Size of downloads: 0 kB
 * Now you can remove -p (or --pretend) from arguments and re-run revdep-rebuild.


I have no mask defined for revdep-rebuild:
set | grep -i mask
CONFIG_PROTECT_MASK='/etc/gentoo-release /etc/sandbox.d /etc/php/cli-php5.5/ext-active/ /etc/php/cgi-php5.5/ext-active/ /etc/php/apache2-php5.5/ext-active/ /etc/fonts/fonts.conf /etc/gconf /etc/terminfo /etc/dconf /etc/ca-certificates.conf /etc/revdep-rebuild'
PRELINK_PATH_MASK=/usr/lib64/klibc:/usr/lib64/libfreebl3.so:/usr/lib64/libnssdbm3.so:/usr/lib64/libsoftokn3.so:/opt/bin/skype


revdep-rebuild python version with --d:
revdep-rebuild -p -i -v --d
 * This is a prerelease version, so it may not work correctly
 * The original revdep-rebuild script is installed as revdep-rebuild.sh
 * Please files bugs at: https://bugs.gentoo.org/
	main(), _libs_to_check = set()
 * Collecting system binaries and libraries
	analyse(), bin directories:
		/bin
		/lib
		/lib32
		/lib64
		/opt/bin
		/sbin
		/usr/bin
		/usr/games/bin
		/usr/lib
		/usr/lib32
		/usr/lib64
		/usr/libexec
		/usr/sbin
		/usr/x86_64-pc-linux-gnu/gcc-bin/4.8.2
	analyse(), lib directories:
		/bin
		/lib
		/lib32
		/lib64
		/sbin
		/usr/bin
		/usr/games/lib
		/usr/games/lib32
		/usr/games/lib64
		/usr/lib
		/usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2
		/usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2/32
		/usr/lib/postgresql
		/usr/lib/qt4
		/usr/lib32
		/usr/lib32/OpenCL/vendors/nvidia
		/usr/lib32/opengl/nvidia/lib
		/usr/lib32/qt4
		/usr/lib64
		/usr/lib64/OpenCL/vendors/nvidia
		/usr/lib64/opengl/nvidia/lib
		/usr/lib64/postgresql
		/usr/lib64/postgresql-9.3/lib64/
		/usr/lib64/qca2
		/usr/lib64/qt4
		/usr/libexec
		/usr/local/lib
		/usr/local/lib32
		/usr/local/lib64
		/usr/sbin
		/usr/x86_64-pc-linux-gnu/lib
	analyse(), masked directories:
		/lib/modules
		/lib32/modules
		/lib64/modules
		/opt/icedtea-bin-7.2.4.3
		/usr/lib64/opera
	analyse(), masked files:
		libjava.so
		libjawt.so
		libjvm.so
		libodbc.so
		libodbcinst.so
	time to complete task: 5 milliseconds
 * Collecting dynamic linking informations
	Exception collecting libraries: [Errno 2] No such file or directory: '/usr/games/lib64'
	Exception collecting libraries: [Errno 2] No such file or directory: '/usr/local/lib32'
	Exception collecting libraries: [Errno 2] No such file or directory: '/usr/games/lib'
	Exception collecting libraries: [Errno 2] No such file or directory: '/usr/games/lib32'
	time to complete task: 5600 milliseconds
	analyse(), Found 17762 libraries (+5334 symlinks) and 5250 binaries
 * Scanning files
	scan(), scanelf params = ['-nBF', '%F %f %S %n %M'], # files: 17794
	scan(), final output length: 15565
	scan_files(); total time to get scanelf data is 304 milliseconds
	scan_files(); total filenames found: 10005 in 782 milliseconds
 * Checking dynamic linking consistency
	analyse(), Searching for 17794 libs, bins within 23096 libraries and links
	LibCheck.search(), Checking for broken 64 bit libs
	LibCheck.search(), Checking for broken 32 bit libs
	LibCheck.search(); total libs found: 2 in 2136 milliseconds
 * Broken files that requires: libperl.so (64 bits)
	* /usr/sbin/nginx
 * Broken files that requires: libjawt.so (64 bits)
	* /usr/lib64/libreoffice/program/libofficebean.so
	LibCheck.process_results(); total filepaths found: 2 in 0 milliseconds
 * Assign files to packages
	* /usr/lib64/libreoffice/program/libofficebean.so -> app-office/libreoffice-4.2.0.4
	* /usr/sbin/nginx -> www-servers/nginx-1.4.4
	assign_packages(); assigned 2 packages, 0 orphans in 676 milliseconds
Traceback (most recent call last):
  File "/usr/lib/python-exec/python3.3/revdep-rebuild", line 40, in <module>
    success = rebuild.main(rebuild.parse_options())
  File "/usr/lib64/python3.3/site-packages/gentoolkit/revdep_rebuild/rebuild.py", line 273, in main
    logger.debug("rebuild return code = %i" %success)
NameError: global name 'success' is not defined
Comment 8 Sławek Lis (RETIRED) gentoo-dev 2014-02-17 10:32:54 UTC
Please re-emerge gentoolkit and try again. There was a typo in latest sources. Sorry for inconvenience.
Comment 9 Cănărău Constantin 2014-02-17 13:49:51 UTC
No problem.
gentoo ~ # revdep-rebuild -p -i --d
 * This is a prerelease version, so it may not work correctly
 * The original revdep-rebuild script is installed as revdep-rebuild.sh
 * Please files bugs at: https://bugs.gentoo.org/
	main(), _libs_to_check = set()
 * Collecting system binaries and libraries
	analyse(), bin directories:
		/bin
		/lib
		/lib32
		/lib64
		/opt/bin
		/sbin
		/usr/bin
		/usr/games/bin
		/usr/lib
		/usr/lib32
		/usr/lib64
		/usr/libexec
		/usr/sbin
		/usr/x86_64-pc-linux-gnu/gcc-bin/4.8.2
	analyse(), lib directories:
		/bin
		/lib
		/lib32
		/lib64
		/sbin
		/usr/bin
		/usr/games/lib
		/usr/games/lib32
		/usr/games/lib64
		/usr/lib
		/usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2
		/usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2/32
		/usr/lib/postgresql
		/usr/lib/qt4
		/usr/lib32
		/usr/lib32/OpenCL/vendors/nvidia
		/usr/lib32/opengl/nvidia/lib
		/usr/lib32/qt4
		/usr/lib64
		/usr/lib64/OpenCL/vendors/nvidia
		/usr/lib64/opengl/nvidia/lib
		/usr/lib64/postgresql
		/usr/lib64/postgresql-9.3/lib64/
		/usr/lib64/qca2
		/usr/lib64/qt4
		/usr/libexec
		/usr/local/lib
		/usr/local/lib32
		/usr/local/lib64
		/usr/sbin
		/usr/x86_64-pc-linux-gnu/lib
	analyse(), masked directories:
		/lib/modules
		/lib32/modules
		/lib64/modules
		/opt/icedtea-bin-7.2.4.3
		/usr/lib64/opera
	analyse(), masked files:
		libjava.so
		libjawt.so
		libjvm.so
		libodbc.so
		libodbcinst.so
	time to complete task: 5 milliseconds
 * Collecting dynamic linking informations
	Exception collecting libraries: [Errno 2] No such file or directory: '/usr/games/lib32'
	Exception collecting libraries: [Errno 2] No such file or directory: '/usr/games/lib'
	Exception collecting libraries: [Errno 2] No such file or directory: '/usr/games/lib64'
	Exception collecting libraries: [Errno 2] No such file or directory: '/usr/local/lib32'
	time to complete task: 5777 milliseconds
	analyse(), Found 17762 libraries (+5334 symlinks) and 5250 binaries
 * Scanning files
	scan(), scanelf params = ['-nBF', '%F %f %S %n %M'], # files: 17794
	scan(), final output length: 15565
	scan_files(); total time to get scanelf data is 280 milliseconds
	scan_files(); total filenames found: 10005 in 788 milliseconds
 * Checking dynamic linking consistency
	analyse(), Searching for 17794 libs, bins within 23096 libraries and links
	LibCheck.search(), Checking for broken 32 bit libs
	LibCheck.search(), Checking for broken 64 bit libs
	LibCheck.search(); total libs found: 2 in 2153 milliseconds
 * Broken files that requires: libperl.so (64 bits)
	* /usr/sbin/nginx
 * Broken files that requires: libjawt.so (64 bits)
	* /usr/lib64/libreoffice/program/libofficebean.so
	LibCheck.process_results(); total filepaths found: 2 in 0 milliseconds
 * Assign files to packages
	* /usr/lib64/libreoffice/program/libofficebean.so -> app-office/libreoffice-4.2.0.4
	* /usr/sbin/nginx -> www-servers/nginx-1.4.4
	assign_packages(); assigned 2 packages, 0 orphans in 638 milliseconds

emerge  --pretend --verbose --oneshot --complete-graph=y app-office/libreoffice:0 www-servers/nginx:0

These are the packages that would be merged, in order:

Calculating dependencies                       ... done!      
[ebuild   R    ] www-servers/nginx-1.4.4  USE="http http-cache ipv6 pcre ssl -aio -debug -libatomic -pcre-jit -rtmp (-selinux) -syslog -vim-syntax" NGINX_MODULES_HTTP="access addition auth_basic autoindex browser cache_purge charset dav empty_gif fancyindex fastcgi flv geo geoip gunzip gzip gzip_static headers_more image_filter limit_conn limit_req map memcached mp4 naxsi perl proxy push random_index realip referer rewrite scgi secure_link spdy split_clients ssi stub_status sub upload_progress upstream_ip_hash userid uwsgi xslt -auth_pam -dav_ext -degradation -echo -lua -metrics -push_stream -security -slowfs_cache -upstream_check" NGINX_MODULES_MAIL="-imap -pop3 -smtp" 0 kB
[ebuild   R    ] app-office/libreoffice-4.2.0.4  USE="branding cups dbus eds gnome gstreamer gtk gtk3 java jemalloc opengl vba webdav (-aqua) -bluetooth -debug (-firebird) -kde -mysql -odk -postgres -telepathy {-test} -vlc" LIBREOFFICE_EXTENSIONS="-nlpsolver -scripting-beanshell -scripting-javascript -wiki-publisher" PYTHON_SINGLE_TARGET="python2_7 -python3_3" PYTHON_TARGETS="python2_7 python3_3" 0 kB

Total: 2 packages (2 reinstalls), Size of downloads: 0 kB
rebuild return code = 0
Comment 10 Alexander Tsoy 2014-03-01 09:06:33 UTC
Same problem with firefox-24.3.0. Shouldn't firefox install config with LD_LIBRARY_MASK in /etc/revdep-rebuild/ ?
Comment 11 Patrick Lauer gentoo-dev 2014-03-14 03:02:58 UTC
$ ldd /usr/lib64/firefox/plugin-container
        linux-vdso.so.1 (0x00007fff1a7ff000)
        libpthread.so.0 => /lib64/libpthread.so.0 (0x0000003000c00000)
        libxul.so => not found
        libstdc++.so.6 => /usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2/libstdc++.so.6 (0x000000300e800000)
        libm.so.6 => /lib64/libm.so.6 (0x0000003001000000)
        libc.so.6 => /lib64/libc.so.6 (0x0000003000400000)
        /lib64/ld-linux-x86-64.so.2 (0x0000003000000000)
        libgcc_s.so.1 => /usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2/libgcc_s.so.1 (0x000000300a000000)

$ ldd /usr/lib64/thunderbird/plugin-container
        linux-vdso.so.1 (0x00007fffbe5a9000)
        libpthread.so.0 => /lib64/libpthread.so.0 (0x0000003000c00000)
        libxul.so => not found
        libstdc++.so.6 => /usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2/libstdc++.so.6 (0x000000300e800000)
        libm.so.6 => /lib64/libm.so.6 (0x0000003001000000)
        libc.so.6 => /lib64/libc.so.6 (0x0000003000400000)
        /lib64/ld-linux-x86-64.so.2 (0x0000003000000000)
        libgcc_s.so.1 => /usr/lib/gcc/x86_64-pc-linux-gnu/4.8.2/libgcc_s.so.1 (0x000000300a000000)

basically same issue

$ equery f firefox | grep xul
/usr/lib/debug/usr/lib64/firefox/libxul.so.debug
/usr/lib64/firefox/browser/extensions/langpack-de@firefox.mozilla.org/chrome/de/locale/de/global/xul.properties
/usr/lib64/firefox/browser/extensions/langpack-en-GB@firefox.mozilla.org/chrome/en-GB/locale/en-GB/global/xul.properties
/usr/lib64/firefox/libxul.so
Comment 12 Paul Varner (RETIRED) gentoo-dev 2014-03-14 19:41:33 UTC
For those of you with this issue, please run:

'revdep-rebuild -ipv' and attach the output and the files from /var/cache/revdep-rebuild to the bug.
Comment 13 Alexander Tsoy 2014-03-14 22:01:52 UTC
I cannot reproduce the problem anymore. revdep-rebuild don't find any linking inconsistencies.

$ ldd /usr/lib64/firefox/plugin-container | grep 'not found'
	libxul.so => not found
Comment 14 Dmitry Derevyanko 2014-03-14 23:11:22 UTC
Created attachment 372684 [details]
Output of `revdep-rebuild -ipv'`
Comment 15 Dmitry Derevyanko 2014-03-14 23:12:08 UTC
Created attachment 372686 [details]
Revdep-rebuild files from /var/cache/revdep-rebuild/*
Comment 16 Paul Varner (RETIRED) gentoo-dev 2014-03-17 15:41:29 UTC
(In reply to Dmitry Derevyanko from comment #15)
> Created attachment 372686 [details]
> Revdep-rebuild files from /var/cache/revdep-rebuild/*

Thanks Dmitry.  All of the files look to be in order. I strongly suspect that I can't fix this in the bash version of revdep-rebuild, but need another test to make sure.

Re-reun the revdep-rebuild -ipv command, then attach the output from the following:

env LD_LIBRARY_PATH="$(cat /var/cache/revdep-rebuild/2_ldpath.rr)" ldd /usr/lib64/firefox/browser/components/libbrowsercomps.so
Comment 17 Dmitry Derevyanko 2014-03-17 19:13:04 UTC
Created attachment 372874 [details]
LD_LIBRARY_PATH="revdep-rebuild/2_ldpath.rr" ldd libbrowsercomps.so

Very strange. Why libs libxul.so and libmozalloc.so are taken from thunderbird?
Comment 18 Jeroen Roovers (RETIRED) gentoo-dev 2014-04-01 19:06:30 UTC
*** Bug 506482 has been marked as a duplicate of this bug. ***
Comment 19 Andreas Oehler 2014-04-06 11:08:41 UTC
Hi, 

i now also ran into this this with firefox 28.0. At least firefox seems to work and i observe the following:

plain firefox from userspace links e.g.:
ldd /usr/lib64/firefox/browser/components/libbrowsercomps.so
        linux-vdso.so.1 (0x00007fff465ff000)
	libpthread.so.0 => /lib64/libpthread.so.0 (0x00007f5dcc0b3000)
	libxul.so => not found
	libmozalloc.so => not found

.. so the libs are not found.

If i search them:

locate libxul.so
/usr/lib64/firefox/libxul.so
/usr/lib64/thunderbird/libxul.so

there is one for firefox and one for thunderbird. They obviously get built with the packages.

If i now run revdep-rebuild, or try what was suggested by Paul:
env LD_LIBRARY_PATH="$(cat /var/cache/revdep-rebuild/2_ldpath.rr)" ldd /usr/lib64/firefox/browser/components/libbrowsercomps.so
/usr/lib64/firefox/browser/components/libbrowsercomps.so: /usr/lib64/thunderbird/libxul.so: version `xul28' not found (required by /usr/lib64/firefox/browser/components/libbrowsercomps.so)
	linux-vdso.so.1 (0x00007fff28da6000)
	libpthread.so.0 => /lib/libpthread.so.0 (0x00007f7275b60000)
	libxul.so => /usr/lib64/thunderbird/libxul.so (0x00007f727279e000)
	libmozalloc.so => /usr/lib64/thunderbird/libmozalloc.so (0x00007f727259b000)
	libnspr4.so => /usr/lib/libnspr4.so (0x00007f727235e000)

Seems like that actually the libs should get more statically linked, 
including the firefox/etc paths. Seems like the revdep rebuild simply adds more paths to ld-librabry path then the first .so found is used, therefore thundbird is find and firefox breaks because the first matching lib is the thunderbird one. Also confirmed by the message above missing the xul28 symbols which are present in the firefox one and not in the thunderbird (24.4, order) one:
readelf -a /usr/lib64/thunderbird/libxul.so|grep xul|head
 0x000000000000000e (SONAME)             Library soname: [libxul.so]
     3: 00000000033c0068     0 NOTYPE  LOCAL  DEFAULT   25 _end@@xul24
     4: 0000000003236c18     0 NOTYPE  LOCAL  DEFAULT   25 __bss_start@@xul24
     5: 0000000003236c18     0 NOTYPE  LOCAL  DEFAULT   24 _edata@@xul24
  2531: 00000000012d21d7     9 FUNC    GLOBAL DEFAULT   11 _ZThn56_N13nsMsgDBFolder2@@xul24
  2532: 0000000001d218c0    60 FUNC    GLOBAL DEFAULT   11 _Z23JS_WriteStructuredClo@@xul24
  2533: 0000000001d1fea0    76 FUNC    GLOBAL DEFAULT   11 _Z22JS_GetGlobalFromScrip@@xul24
  2534: 0000000001c79f87     1 FUNC    GLOBAL DEFAULT   11 XPT_FreeInterfaceDescript@@xul24
  2535: 00000000018df0e0    22 FUNC    GLOBAL DEFAULT   11 gr_tag_to_str@@xul24
  2536: 0000000001bbc48f    44 FUNC    WEAK   DEFAULT   11 _ZNSt11__copy_moveILb0ELb@@xul24

readelf -a /usr/lib64/firefox/libxul.so|grep xul|head
 0x000000000000000e (SONAME)             Library soname: [libxul.so]
    48: 0000000000000000     4 TLS     LOCAL  HIDDEN    18 gTLSThreadID@@xul28
  2555: 0000000001c0271b    11 FUNC    GLOBAL DEFAULT   13 XPT_GetXDRDataLength@@xul28
  2556: 00000000018ca43e   103 FUNC    WEAK   DEFAULT   13 _ZNSt8_Rb_treeImSt4pairIK@@xul28
  2557: 0000000001b4387c    62 FUNC    WEAK   DEFAULT   13 _ZNSt5dequeIiSaIiEED1Ev@@xul28
  2558: 0000000000acf215   123 FUNC    WEAK   DEFAULT   13 _ZSt6__findIPKccET_S2_S2_@@xul28


Long story short: as long as the xul versions are alike enugh or the ld-path order , noone notices. The other question: obviously firefox/thunderbird seem to run without these links, what do i need them for?

Hope that helped a bit...
Comment 20 Juergen Rose 2014-04-10 10:27:47 UTC
Is there not any workaround for this bug? It is very nasty that firefox and seamonkey is emerged every by 'emerge @preserved-rebuild' or 'revdep-rebuild'.
Comment 21 Cănărău Constantin 2014-04-10 12:14:46 UTC
Workaround ? Not a real one. But you can hide the error under carpet :)
cat /etc/revdep-rebuild/91firefox
LD_LIBRARY_MASK="libmozalloc.so libxul.so"
Comment 22 Juergen Rose 2014-04-27 17:05:52 UTC
(In reply to Cănărău Constantin from comment #21)
> Workaround ? Not a real one. But you can hide the error under carpet :)
> cat /etc/revdep-rebuild/91firefox
> LD_LIBRARY_MASK="libmozalloc.so libxul.so"

Thanks Constantin, 
this works so far.
Comment 23 xyz 2014-06-14 07:01:21 UTC
Same problem with firefox-24.5.0 and firefox-24.6.0
Comment 24 xyz 2014-06-14 07:32:07 UTC
According to forum topic
https://forums.gentoo.org/viewtopic-t-927376-highlight-firefox.html
SEARCH_DIRS_MASK is more correct way to solve this bug.

cat /etc/revdep-rebuild/91firefox
SEARCH_DIRS_MASK="/usr/lib64/firefox"
Comment 25 Andreas Prieß 2014-10-02 10:38:53 UTC
I do not know how the details work, but interestingly the problem disappeared on my desktop systems after rebuilding "--emptytree system" with GCC 4.8.
Comment 26 Jonas Stein gentoo-dev 2019-01-06 18:06:16 UTC
looks like a broken world update from a decade ago. We can close it.